<p align="center">
    <img src="doc/assets/icon.png" alt="icon" width="200"/>
</p>

coincoincoin - an exploration of the ethereum blockchain and smart contracts

- [Introduction](#introduction)
- [Getting Started](#getting-started)

## Introduction

> What's an Ethereum?
> Ethereum is a decentralized platform that runs smart contracts: applications that run exactly as programmed without any possibility of downtime, fraud or third party interference. These apps run on a custom built blockchain, an enormously powerful shared global infrastructure that can move value around and represent the ownership of property.

**Ether** is the currency of the Ethereum blockchain. It is a form of payment made by the clients of the platform to the machines executing the requested operations. To put it another way, ether is the incentive ensuring that developers write quality applications (wasteful code costs more), and that the network remains healthy (people are compensated for their contributed resources).

> Smart contracts?

Smart contracts are self-executing contracts with the terms of the agreement between buyer and seller being directly written into lines of code. The code and the agreements contained therein exist across a distributed, decentralized blockchain network. Smart contracts permit trusted transactions and agreements to be

Types of smart contracts include:

| Name     | Buzzwords                                             | Real explanation                                                                                                                                                                         |
| -------- | ----------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| ERC-20   | Fungible tokens, DeFi, Utility Tokens                 | The standard for fungible tokens on Ethereum. Used for cryptocurrencies like USDC and DAI. Tokens are interchangeable, meaning each unit is the same as another (e.g., 1 USDC = 1 USDC). |
| ERC-721  | NFTs, Unique assets, Digital collectibles             | The standard for **Non-Fungible Tokens (NFTs)**. Each token is unique, making it perfect for digital art, real estate, and in-game items. Used in platforms like [OpenSea](https://opensea.io).                |
| ERC-1155 | Multi-token standard, Gas-efficient, Hybrid tokens    | Supports **both** fungible and non-fungible tokens in a single contract. More gas-efficient for batch transfers. Popular in gaming (e.g., [Enjin](https://enjin.io)).                                        |
| ERC-4626 | Yield-bearing vaults, DeFi, Tokenized Vaults          | A standard for tokenized yield vaults in DeFi. It makes it easier to deposit assets into lending/staking platforms and get interest-bearing tokens in return.                            |
| ERC-777  | Advanced ERC-20, Hooks, Gas-efficient                 | An improved version of ERC-20 with **hooks** (allowing smart contract interactions on transfers). Enables more efficient token transactions and is backwards-compatible with ERC-20.     |
| ERC-2981 | NFT Royalties, Creator earnings, Marketplace standard | Adds royalty information to NFTs, allowing creators to automatically receive a percentage of sales when their NFTs are resold on marketplaces.                                           |
| ERC-6059 | Nested NFTs, Composable assets, On-chain hierarchies  | Allows NFTs to own other NFTs (nested ownership). Useful for metaverse projects, gaming, and dynamic NFT structures (e.g., a character NFT that owns weapon NFTs).                       |


## Getting Started

Read how to set up the environment like I did [here](doc/01_environment.md)

Are you done with that? Check out the [minimal example](doc/02_minimal.md) to deploy a smart contract to the Ethereum blockchain.
